define(function () { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var makePlugin = function (utils) {
        var customPlugin = {
            id: "dtshelper",
            displayName: "d.ts helper",
            didMount: function (sandbox, container) { return __awaiter(void 0, void 0, void 0, function () {
                var options, _a, createSystem, createDefaultMapFromCDN, createVirtualCompilerHost, fsMap, ds, startButton, name;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            console.log("Showing new plugin");
                            options = __assign(__assign({}, sandbox.getCompilerOptions()), { allowJs: true, checkJs: true });
                            _a = sandbox.tsvfs, createSystem = _a.createSystem, createDefaultMapFromCDN = _a.createDefaultMapFromCDN, createVirtualCompilerHost = _a.createVirtualCompilerHost;
                            return [4 /*yield*/, createDefaultMapFromCDN(options, sandbox.ts.version, true, sandbox.ts)
                                // Create a design system object to handle
                                // making DOM elements which fit the playground (and handle mobile/light/dark etc)
                            ];
                        case 1:
                            fsMap = _b.sent();
                            ds = utils.createDesignSystem(container);
                            ds.title("Generate d.ts from JS");
                            ds.p("Put the name of an npm package to generate a d.ts from it");
                            startButton = document.createElement("input");
                            startButton.type = "button";
                            startButton.value = "Load npm package";
                            name = document.createElement("input");
                            name.type = "input";
                            name.value = "barn";
                            container.appendChild(name);
                            container.appendChild(startButton);
                            startButton.onclick = function () { return __awaiter(void 0, void 0, void 0, function () {
                                var unpkgfs, jss, _i, jss_1, js, _a, _b, _c, p, main, indexjs, system, host, program, sourceFile;
                                return __generator(this, function (_d) {
                                    switch (_d.label) {
                                        case 0: return [4 /*yield*/, jfetch("https://unpkg.com/" + name.value + "/?meta", sandbox.setText)];
                                        case 1:
                                            unpkgfs = _d.sent();
                                            jss = flatpkg(unpkgfs).filter(function (f) { return f.endsWith('.js'); });
                                            if (!(jss.length <= 10)) return [3 /*break*/, 6];
                                            _i = 0, jss_1 = jss;
                                            _d.label = 2;
                                        case 2:
                                            if (!(_i < jss_1.length)) return [3 /*break*/, 5];
                                            js = jss_1[_i];
                                            console.log(js);
                                            _b = (_a = fsMap).set;
                                            _c = [js];
                                            return [4 /*yield*/, jfetch("https://unpkg.com/" + name.value + js, sandbox.setText, /*returnText*/ true)];
                                        case 3:
                                            _b.apply(_a, _c.concat([_d.sent()]));
                                            _d.label = 4;
                                        case 4:
                                            _i++;
                                            return [3 /*break*/, 2];
                                        case 5: return [3 /*break*/, 7];
                                        case 6:
                                            console.log('Too many javascript files to download: ' + jss.length);
                                            _d.label = 7;
                                        case 7: return [4 /*yield*/, jfetch("https://unpkg.com/" + name.value + "/package.json", sandbox.setText)];
                                        case 8:
                                            p = _d.sent();
                                            main = lookupMain(p.main);
                                            console.log(main);
                                            return [4 /*yield*/, jfetch("https://unpkg.com/" + name.value + main, sandbox.setText, /*returnText*/ true)];
                                        case 9:
                                            indexjs = _d.sent();
                                            fsMap.set(main, indexjs);
                                            system = createSystem(fsMap);
                                            host = createVirtualCompilerHost(system, options, sandbox.ts);
                                            program = sandbox.ts.createProgram({
                                                rootNames: [main],
                                                options: options,
                                                host: host.compilerHost
                                            });
                                            console.log('after creating program');
                                            sourceFile = program.getSourceFile(main);
                                            console.log(program.emit(sourceFile, undefined, undefined, true));
                                            console.log(system.readDirectory("/"));
                                            sandbox.setText(system.readFile(main.slice(0, main.length - 3) + ".d.ts"));
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            return [2 /*return*/];
                    }
                });
            }); },
            // This is called occasionally as text changes in monaco,
            // it does not directly map 1 keyup to once run of the function
            // because it is intentionally called at most once every 0.3 seconds
            // and then will always run at the end.
            modelChangedDebounce: function (_sandbox, _model) { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/];
                });
            }); },
            // Gives you a chance to remove anything set up,
            // the container itself if wiped of children after this.
            didUnmount: function () {
                console.log("De-focusing plugin");
            },
        };
        return customPlugin;
    };
    function jfetch(url, log, returnText) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        log("// FETCHING " + url + " ...");
                        return [4 /*yield*/, fetch(url)];
                    case 1:
                        response = _a.sent();
                        if (!response.ok) {
                            log("// NOPE: " + response.statusText);
                            return [2 /*return*/, {}];
                        }
                        else {
                            return [2 /*return*/, returnText ? response.text() : response.json()];
                        }
                }
            });
        });
    }
    /// a flat list of files from the unpkg fs
    function flatpkg(ufs) {
        if (ufs.type === "file")
            return [ufs.path];
        else
            return flatMap(ufs.files, flatpkg);
    }
    function flatMap(l, f) {
        if (Array.prototype.hasOwnProperty('flatMap'))
            return Array.prototype.flatMap.call(l, f);
        var acc = [];
        for (var _i = 0, l_1 = l; _i < l_1.length; _i++) {
            var x = l_1[_i];
            acc.push.apply(acc, f(x));
        }
        return acc;
    }
    function lookupMain(main) {
        if (!main)
            main = "index.js";
        if (!main.endsWith('.js'))
            main += '.js';
        main = main.replace('./', '');
        return '/' + main;
    }

    return makePlugin;

});
